Private Sub mnuPopupCreateCast_Click()
On Error GoTo Err_Handler
svr.LogEvent "Entering " & App.Title & ":frmMain.mnuPopupCreateCast_Click()", etFullDebug

Dim objCastForm As New frmCast

  Load objCastForm
  objCastForm.Initialise ctx.CurrentDB
  objCastForm.Show
  
  Exit Sub
Err_Handler: If Err.Number <> 0 Then LogError Err.Number, Err.Description, App.Title & ":frmMain.mnuPopupCreateCast_Click"
End Sub



Private Sub mnuPopupProperties_Click()
.....
        Case "Cast"
          Dim objCastForm As New frmCast
          Load objCastForm
          objCastForm.Initialise ctx.CurrentDB, ctx.CurrentObject
          objCastForm.Show
.....
End Sub


Private Sub tvDatabase(ByVal Node As MSComctlLib.Node)
.....
      Set ctx.CurrentObject.Languages.Tag = tv.Nodes.Add(Node.Key, tvwChild, "LNG+" & GetID, "Languages (" & ctx.CurrentObject.Languages.Count(Not ctx.IncludeSys) & ")", "language")
      If ctx.dbVer >= 7.3 Then
        Set ctx.CurrentObject.Casts.Tag = tv.Nodes.Add(Node.Key, tvwChild, "CST+" & GetID, "Casts (" & ctx.CurrentObject.Casts.Count(Not ctx.IncludeSys) & ")", "cast")
      End If
.....
End Sub



Private Sub tvCasts(ByVal Node As MSComctlLib.Node)
On Error GoTo Err_Handler
svr.LogEvent "Entering " & App.Title & ":frmMain.tvCasts(" & QUOTE & Node.FullPath & QUOTE & ")", etFullDebug

Dim lvItem As ListItem
Dim cst As pgCast

  If Node.Children = 0 Or Node.Children <> svr.Databases(Node.Parent.Text).Casts.Count(Not ctx.IncludeSys) Then
    While Not (Node.Child Is Nothing)
      tv.Nodes.Remove Node.Child.Index
    Wend
    For Each cst In svr.Databases(Node.Parent.Text).Casts
      If Not (cst.SystemObject And Not ctx.IncludeSys) Then Set cst.Tag = tv.Nodes.Add(Node.Key, tvwChild, "CST-" & GetID, cst.Identifier, "cast")
    Next cst
    Node.Text = "Casts (" & Node.Children & ")"
  End If
  lv.ColumnHeaders.Add , , "Cast", lv.Width
  For Each cst In svr.Databases(Node.Parent.Text).Casts
    If Not (cst.SystemObject And Not ctx.IncludeSys) Then
      Set lvItem = lv.ListItems.Add(, "CST-" & GetID, cst.Identifier, "cast", "cast")
    End If
  Next cst
  
  Exit Sub
Err_Handler: If Err.Number <> 0 Then LogError Err.Number, Err.Description, App.Title & ":frmMain.tvCasts"
End Sub


Private Sub tvCast(ByVal Node As MSComctlLib.Node)
On Error GoTo Err_Handler
svr.LogEvent "Entering " & App.Title & ":frmMain.tvCast(" & QUOTE & Node.FullPath & QUOTE & ")", etFullDebug

Dim lvItem As ListItem

  lv.ColumnHeaders.Add , , "Property", 2000
  lv.ColumnHeaders.Add , , "Value", FixWidth(lv.Width - 2100)
  
  Set lvItem = lv.ListItems.Add(, "PRO-" & GetID, "Name", "property", "property")
  lvItem.SubItems(1) = ctx.CurrentObject.Name
  Set lvItem = lv.ListItems.Add(, "PRO-" & GetID, "OID", "property", "property")
  lvItem.SubItems(1) = ctx.CurrentObject.OID
  Set lvItem = lv.ListItems.Add(, "PRO-" & GetID, "Type source", "property", "property")
  lvItem.SubItems(1) = ctx.CurrentObject.Source
  Set lvItem = lv.ListItems.Add(, "PRO-" & GetID, "Type target", "property", "property")
  lvItem.SubItems(1) = ctx.CurrentObject.Target
  Set lvItem = lv.ListItems.Add(, "PRO-" & GetID, "Function", "property", "property")
  lvItem.SubItems(1) = ctx.CurrentObject.Funct
  Set lvItem = lv.ListItems.Add(, "PRO-" & GetID, "Context", "property", "property")
  
  Select Case ctx.CurrentObject.Context
    Case "e"
    Case "i"
      lvItem.SubItems(1) = "Implict"
    Case "a"
      lvItem.SubItems(1) = "Assigment"
  End Select
  
  Set lvItem = lv.ListItems.Add(, "PRO-" & GetID, "System Cast?", "property", "property")
  If ctx.CurrentObject.SystemObject Then
    lvItem.SubItems(1) = "Yes"
  Else
    lvItem.SubItems(1) = "No"
  End If
  
  'Set the Definition Pane
  If txtDefinition.Visible Then txtDefinition.Text = ctx.CurrentObject.SQL
  
  Exit Sub
Err_Handler: If Err.Number <> 0 Then LogError Err.Number, Err.Description, App.Title & ":frmMain.tvCast"
End Sub

Public Sub tv_NodeClick(ByVal Node As MSComctlLib.Node)
.....
    Case "CST+" 'Casts
      ctx.CurrentDB = Node.Parent.Text
      ctx.CurrentNS = ""
      tvCasts Node
      ClearStats
    
    Case "CST-" 'Cast
      ctx.CurrentDB = Node.Parent.Parent.Text
      ctx.CurrentNS = ""
      Set ctx.CurrentObject = svr.Databases(Node.Parent.Parent.Text).Casts(Node.Text)
      tvCast Node
      ClearStats
.....
End Sub

Private Sub lv_ItemClick(ByVal Item As MSComctlLib.ListItem)
.....
    Case "CST-" 'Cast
      Set ctx.CurrentObject = svr.Databases(szPath(2)).Casts(Item.Text)
      ctx.CurrentDB = ctx.CurrentObject.Database
      ctx.CurrentNS = ""
      If txtDefinition.Visible Then txtDefinition.Text = ctx.CurrentObject.SQL
.....
End Sub

